//SMT.c
//Symulator maszyny Turinga - klasa
#include "stdafx.h"

using namespace std;
//using namespace System;

#define MAX_STANY 100
#define MAX_SYMBOLE 100

enum {MT_PUSTA,MT_USTAWIONA,MT_WLACZONA,MT_ZATRZYMANA,MT_WYKONANA};

struct OpisStanu
{
	int kolejny_stan;
	char symbol;
	int przesun;	//Dostpne opcje: -1,0,1
};

class SymulatorMaszyny
{
//private:
public:
	//parametry maszyny
	OpisStanu OpisProgramu[MAX_STANY][MAX_SYMBOLE];
	string symbolewejsciowe;
	string symbole;
	char pusty_symbol;
    //parametry aktualne
	int status;
	int aktualny_stan;
	unsigned int ile_stanow;
	unsigned int ile_symboli;
	vector<char> tasma;
	unsigned int pozycja_glowicy;
	unsigned int pos1;
	unsigned int pos2;

	SymulatorMaszyny()
	{
		aktualny_stan=0;
		pozycja_glowicy=0;
		pusty_symbol='#';
		status=MT_PUSTA;
		pos1=0;pos2=0;
		OpisProgramu[0][0].kolejny_stan=12;
		OpisProgramu[0][0].symbol='a';
		OpisProgramu[0][0].przesun=1;
	}

	SymulatorMaszyny(int ilosc_stanow,string listasymboli,char pusty,int stan_poczatkowy)
	{
		aktualny_stan=0;
		pozycja_glowicy=0;
		pusty_symbol=pusty;
		symbole=listasymboli;
		aktualny_stan=stan_poczatkowy;
		status=MT_USTAWIONA;
		pos1=0;pos2=0;
	}

	void Wyczysc_program()
	{
		for(int i=0;i<MAX_STANY;i++)
		{
			for(int j=0;j<MAX_SYMBOLE;j++)
			{
				OpisProgramu[i][j].kolejny_stan=0;
				OpisProgramu[i][j].symbol='#';
				OpisProgramu[i][j].przesun=0;
			}
		}
	}

	//Dodaje nowy wiersz do tabeli z programem = nowy stan
	void Dodaj_stan(unsigned int num)
	{
		if(ile_stanow+1>=MAX_STANY){return;}
		ile_stanow++;
		for(unsigned int i=0;i<MAX_SYMBOLE;i++)
		{
			OpisProgramu[ile_stanow][i].kolejny_stan=0;
			OpisProgramu[ile_stanow][i].symbol='#';
			OpisProgramu[ile_stanow][i].przesun=0;
		}
		
	}	

	bool Przesun_glowice(int num)
	{
		if(num == 1 && pozycja_glowicy+1 > tasma.size())	//Jeli glowica wyjdzie poza znany zakres tasmy
		{ 
			tasma.push_back(pusty_symbol);					//Dodajemy element na kocu tasmy
			pozycja_glowicy++;
			return true;
		}
		if(num == -1 && pozycja_glowicy == 0)				//Jeli wyjdzie przed znany zakres
		{
			return false;									//Blad - nie mona wyjecha przez zakres
		}
		else if(num!=0){return false;}						//Blad - nieznana liczba
	}

	bool Dodaj_tasme(vector<char> tape,int stan)
	{
		tasma=tape;
		aktualny_stan=stan;
	}

	bool Znajdz_stan(OpisStanu* opis,unsigned int stan,char symbol)
	{
		bool znaleziono=false;
		if(stan>=ile_stanow){return false;}
		int num=-1;
		for(unsigned int i=0;i<symbole.length();i++)
		{
			if(symbole[i]==symbol){num=i;}
		}
		if(num==-1){return false;}
		opis = &OpisProgramu[stan][num];
		return true;									//Znaleziono i zapisano (1 dla if'ow)
	}

	string OpisChwilowy()
	{
		string opis;
	
		for(unsigned int i=0;i<pozycja_glowicy;i++)
		{opis+=tasma[i];}
		char buff[3];
		_itoa_s(aktualny_stan,buff,10);
		if(aktualny_stan<10){opis+="(q0";}
		else{opis+="(q";}
		opis+=buff;
		opis+=")";
		for(unsigned int i=pozycja_glowicy;i<tasma.size();i++)
		{opis+=tasma[i];}
		return opis;
	}
	string PobierzKomorke(int stannum,int symbolnum)
	{
		bool znaleziono=false;
		if(stannum+pos1>=ile_stanow){return "";}
		if(symbolnum+pos2>=symbole.length()){return "";}
		OpisStanu opis = OpisProgramu[stannum+pos1][symbolnum+pos2];
		string tekst="";
		if(opis.kolejny_stan<10){tekst+="0";}
		tekst+=opis.kolejny_stan;
		tekst+=opis.symbol;
		if(opis.symbol== 1){tekst+="P";}
		else if(opis.symbol==-1){tekst+="L";}
		else{tekst+="-";}
		return tekst;
	}
	void Wykonaj()
	{
		
	}
  
};